/** @file */
/***********************************************

 !!!! DO NOT EDIT THIS FILE !!!!

 All content has been auto-generated by 
 the boilerplater.pl utility.

 See boilerplater's documentation for details.

 ***********************************************/



#ifndef R_KINO_POSTINGPOOL
#define R_KINO_POSTINGPOOL 1

#include "KinoSearch/Index/PostingPool.h"

#define KINO_POSTINGPOOL_BOILERPLATE

typedef void
(*kino_PostPool_destroy_t)(kino_PostingPool *self);

typedef chy_u32_t
(*kino_PostPool_refill_t)(kino_PostingPool *self);

typedef void
(*kino_PostPool_add_batch_t)(kino_PostingPool *self, 
                        struct kino_TokenBatch *batch, 
                        chy_i32_t doc_num, 
                        float doc_boost, 
                        float length_norm);

typedef void
(*kino_PostPool_add_posting_t)(kino_PostingPool *self, 
                          struct kino_RawPosting *raw_posting);

typedef void
(*kino_PostPool_assign_seg_t)(kino_PostingPool *self, 
                         struct kino_Folder *other_folder, 
                         struct kino_SegInfo *other_seg_info, 
                         chy_u32_t doc_base, 
                         struct kino_IntMap *doc_map);

typedef struct kino_RawPosting*
(*kino_PostPool_fetch_from_ram_t)(kino_PostingPool *self);

typedef void
(*kino_PostPool_flip_t)(kino_PostingPool *self, 
                   struct kino_InStream *lex_instream,
                   struct kino_InStream *post_instream,
                   chy_u32_t mem_thresh);

typedef void
(*kino_PostPool_sort_cache_t)(kino_PostingPool *self);

#define Kino_PostPool_Clone(self) \
    (self)->_->clone((kino_Obj*)self)

#define Kino_PostPool_Destroy(self) \
    (self)->_->destroy((kino_Obj*)self)

#define Kino_PostPool_Equals(self, other) \
    (self)->_->equals((kino_Obj*)self, other)

#define Kino_PostPool_Hash_Code(self) \
    (self)->_->hash_code((kino_Obj*)self)

#define Kino_PostPool_Is_A(self, target_vtable) \
    (self)->_->is_a((kino_Obj*)self, target_vtable)

#define Kino_PostPool_To_String(self) \
    (self)->_->to_string((kino_Obj*)self)

#define Kino_PostPool_Serialize(self, target) \
    (self)->_->serialize((kino_Obj*)self, target)

#define Kino_PostPool_Refill(self) \
    (self)->_->refill((kino_SortExRun*)self)

#define Kino_PostPool_Grow_Cache(self, new_cache_cap) \
    (self)->_->grow_cache((kino_SortExRun*)self, new_cache_cap)

#define Kino_PostPool_Peek_Last(self) \
    kino_SortExRun_peek_last((kino_SortExRun*)self)

#define Kino_PostPool_Prepare_Slice(self, endpost) \
    kino_SortExRun_prepare_slice((kino_SortExRun*)self, endpost)

#define Kino_PostPool_Pop_Slice(self, slice_size) \
    kino_SortExRun_pop_slice((kino_SortExRun*)self, slice_size)

#define Kino_PostPool_Clear_Cache(self) \
    (self)->_->clear_cache((kino_SortExRun*)self)

#define Kino_PostPool_Add_Batch(self, batch, doc_num, doc_boost, length_norm) \
    (self)->_->add_batch((kino_PostingPool*)self, batch, doc_num, doc_boost, length_norm)

#define Kino_PostPool_Add_Posting(self, raw_posting) \
    (self)->_->add_posting((kino_PostingPool*)self, raw_posting)

#define Kino_PostPool_Assign_Seg(self, other_folder, other_seg_info, doc_base, doc_map) \
    (self)->_->assign_seg((kino_PostingPool*)self, other_folder, other_seg_info, doc_base, doc_map)

#define Kino_PostPool_Fetch_From_RAM(self) \
    (self)->_->fetch_from_ram((kino_PostingPool*)self)

#define Kino_PostPool_Flip(self, lex_instream, post_instream, mem_thresh) \
    (self)->_->flip((kino_PostingPool*)self, lex_instream, post_instream, mem_thresh)

#define Kino_PostPool_Sort_Cache(self) \
    (self)->_->sort_cache((kino_PostingPool*)self)

struct KINO_POSTINGPOOL_VTABLE {
    KINO_OBJ_VTABLE *_;
    chy_u32_t refcount;
    KINO_OBJ_VTABLE *parent;
    const char *class_name;
    kino_Obj_clone_t clone;
    kino_Obj_destroy_t destroy;
    kino_Obj_equals_t equals;
    kino_Obj_hash_code_t hash_code;
    kino_Obj_is_a_t is_a;
    kino_Obj_to_string_t to_string;
    kino_Obj_serialize_t serialize;
    kino_SortExRun_refill_t refill;
    kino_SortExRun_grow_cache_t grow_cache;
    kino_SortExRun_peek_last_t peek_last;
    kino_SortExRun_prepare_slice_t prepare_slice;
    kino_SortExRun_pop_slice_t pop_slice;
    kino_SortExRun_clear_cache_t clear_cache;
    kino_PostPool_add_batch_t add_batch;
    kino_PostPool_add_posting_t add_posting;
    kino_PostPool_assign_seg_t assign_seg;
    kino_PostPool_fetch_from_ram_t fetch_from_ram;
    kino_PostPool_flip_t flip;
    kino_PostPool_sort_cache_t sort_cache;
};

extern KINO_POSTINGPOOL_VTABLE KINO_POSTINGPOOL;

#ifdef KINO_USE_SHORT_NAMES
  #define PostingPool kino_PostingPool
  #define POSTINGPOOL KINO_POSTINGPOOL
  #define PostPool_new kino_PostPool_new
  #define PostPool_destroy kino_PostPool_destroy
  #define PostPool_refill kino_PostPool_refill
  #define PostPool_add_batch_t kino_PostPool_add_batch_t
  #define PostPool_add_batch kino_PostPool_add_batch
  #define PostPool_add_posting_t kino_PostPool_add_posting_t
  #define PostPool_add_posting kino_PostPool_add_posting
  #define PostPool_assign_seg_t kino_PostPool_assign_seg_t
  #define PostPool_assign_seg kino_PostPool_assign_seg
  #define PostPool_fetch_from_ram_t kino_PostPool_fetch_from_ram_t
  #define PostPool_fetch_from_ram kino_PostPool_fetch_from_ram
  #define PostPool_flip_t kino_PostPool_flip_t
  #define PostPool_flip kino_PostPool_flip
  #define PostPool_sort_cache_t kino_PostPool_sort_cache_t
  #define PostPool_sort_cache kino_PostPool_sort_cache
  #define PostPool_Clone Kino_PostPool_Clone
  #define PostPool_Destroy Kino_PostPool_Destroy
  #define PostPool_Equals Kino_PostPool_Equals
  #define PostPool_Hash_Code Kino_PostPool_Hash_Code
  #define PostPool_Is_A Kino_PostPool_Is_A
  #define PostPool_To_String Kino_PostPool_To_String
  #define PostPool_Serialize Kino_PostPool_Serialize
  #define PostPool_Refill Kino_PostPool_Refill
  #define PostPool_Grow_Cache Kino_PostPool_Grow_Cache
  #define PostPool_Peek_Last Kino_PostPool_Peek_Last
  #define PostPool_Prepare_Slice Kino_PostPool_Prepare_Slice
  #define PostPool_Pop_Slice Kino_PostPool_Pop_Slice
  #define PostPool_Clear_Cache Kino_PostPool_Clear_Cache
  #define PostPool_Add_Batch Kino_PostPool_Add_Batch
  #define PostPool_Add_Posting Kino_PostPool_Add_Posting
  #define PostPool_Assign_Seg Kino_PostPool_Assign_Seg
  #define PostPool_Fetch_From_RAM Kino_PostPool_Fetch_From_RAM
  #define PostPool_Flip Kino_PostPool_Flip
  #define PostPool_Sort_Cache Kino_PostPool_Sort_Cache
#endif /* KINO_USE_SHORT_NAMES */

#define KINO_POSTINGPOOL_MEMBER_VARS \
    chy_u32_t  refcount; \
    kino_MSort_compare_t  compare; \
    kino_Obj * context; \
    kino_Obj ** cache; \
    chy_u32_t  cache_cap; \
    chy_u32_t  cache_max; \
    chy_u32_t  cache_tick; \
    chy_u32_t  slice_size; \
    struct kino_Schema * schema; \
    struct kino_ByteBuf * field_name; \
    struct kino_FieldSpec * fspec; \
    struct kino_Posting * posting; \
    struct kino_TermStepper * term_stepper; \
    struct kino_MemoryPool * mem_pool; \
    struct kino_InStream * lex_instream; \
    struct kino_InStream * post_instream; \
    struct kino_IntMap * doc_map; \
    kino_Obj ** scratch; \
    chy_u32_t  scratch_cap; \
    chy_u64_t  lex_start; \
    chy_u64_t  post_start; \
    chy_u64_t  lex_end; \
    chy_u64_t  post_end; \
    chy_u32_t  mem_thresh; \
    chy_u32_t  doc_base; \
    chy_u32_t  last_doc_num; \
    chy_u32_t  post_count; \
    chy_bool_t  flipped; \
    chy_bool_t  from_seg

#ifdef KINO_WANT_POSTINGPOOL_VTABLE
KINO_POSTINGPOOL_VTABLE KINO_POSTINGPOOL = {
    (KINO_OBJ_VTABLE*)&KINO_VIRTUALTABLE,
    1,
    (KINO_OBJ_VTABLE*)&KINO_SORTEXRUN,
    "KinoSearch::Index::PostingPool",
    (kino_Obj_clone_t)kino_Obj_clone,
    (kino_Obj_destroy_t)kino_PostPool_destroy,
    (kino_Obj_equals_t)kino_Obj_equals,
    (kino_Obj_hash_code_t)kino_Obj_hash_code,
    (kino_Obj_is_a_t)kino_Obj_is_a,
    (kino_Obj_to_string_t)kino_Obj_to_string,
    (kino_Obj_serialize_t)kino_Obj_serialize,
    (kino_SortExRun_refill_t)kino_PostPool_refill,
    (kino_SortExRun_grow_cache_t)kino_SortExRun_grow_cache,
    (kino_SortExRun_peek_last_t)kino_SortExRun_peek_last,
    (kino_SortExRun_prepare_slice_t)kino_SortExRun_prepare_slice,
    (kino_SortExRun_pop_slice_t)kino_SortExRun_pop_slice,
    (kino_SortExRun_clear_cache_t)kino_SortExRun_clear_cache,
    (kino_PostPool_add_batch_t)kino_PostPool_add_batch,
    (kino_PostPool_add_posting_t)kino_PostPool_add_posting,
    (kino_PostPool_assign_seg_t)kino_PostPool_assign_seg,
    (kino_PostPool_fetch_from_ram_t)kino_PostPool_fetch_from_ram,
    (kino_PostPool_flip_t)kino_PostPool_flip,
    (kino_PostPool_sort_cache_t)kino_PostPool_sort_cache
};
#endif /* KINO_WANT_POSTINGPOOL_VTABLE */

#undef KINO_POSTINGPOOL_BOILERPLATE


#endif /* R_KINO_POSTINGPOOL */


/* Copyright 2007 Marvin Humphrey
 *
 * This program is free software; you can redistribute it and/or modify
 * under the same terms as Perl itself.
 */

